package com.sf.day09.lx3;

public class DepositCard {
    private String id;  //账户的id
    private double balance;   //账户的余额


    /**
     * 取款
     * @param money  取款金额
     */
    public void withdraw(double money){
        if(money < 0){
            System.out.println("取款金额不能为负数");
            return;
        }
        if(money > balance){
            System.out.println("提示余额不足!!");
            return;
        }
        balance -= money;
    }

    /**
     * 存款
     * @param money  存款金额
     */
    public void save(double money){
        if(money < 0){
            System.out.println("存款金额不能为负数");
            return;
        }
        balance += money;
    }

    /**
     * 返回账户信息
     * @return
     */
    public String getInfo(){
        return "账户ID = "+id+"    账户余额" + balance;
    }


    public DepositCard() {
    }

    public DepositCard(String id, double balance) {
        this.id = id;
        this.balance = balance;
    }

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public double getBalance() {
        return balance;
    }

    public void setBalance(double balance) {
        this.balance = balance;
    }

    @Override
    public String toString() {
        return "DepositCard{" +
                "id='" + id + '\'' +
                ", balance=" + balance +
                '}';
    }
}
