package com.sf.day17._01_set;

import com.sf.day17._01_set.dt.Employee;
import com.sf.day17._01_set.dt.Student;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.Iterator;
import java.util.TreeSet;

/**
 * create By  fjl
 */
public class TestTreeSet {

    public static void main(String[] args) {
//        method2();


//        method3();
        method4();
    }

    private static void method4() {
        // 按照年龄进行排序
        // Compareable 和comparetor 接口区别
        /**
         *  相同点: 两个都可以去进行比较操作
         *  区别: 主要就是应用场景区别
         *  如果没有特殊要求的话, 使用他们两个都可以
         *  比如我们要对于一些第三方框架类进行排序操作, 这些类没有实现Comparable接口那此时我们稚嫩个
         *  使用和comparetor
         */
        TreeSet<Student> treeSet = new TreeSet<>(new Comparator<Student>() {
            @Override
            public int compare(Student o1, Student o2) {
                if (o1.getName().length() > o2.getName().length()) {
                    return 1;
                } else if (o1.getName().length() < o2.getName().length()) {
                    return -1;
                } else {
                    return 0;
                }
            }
        });

        treeSet.add(new Student("zhangsan", 18));
        treeSet.add(new Student("lisi", 10));
        treeSet.add(new Student("wangwu", 30));
        System.out.println(treeSet);

    }


    private static void method3() {
        /**
         * 需求: 现在有4用户(name,age,intergral) , 100,300,200,50
         * 要求打印积分高的前两个 姓名和积分
         */
        TreeSet<Employee> treeSet = new TreeSet<>();
        treeSet.add(new Employee("zhangsan", 10, 100));
        treeSet.add(new Employee("lisi", 20, 300));
        treeSet.add(new Employee("wangwu", 30, 200));
        treeSet.add(new Employee("zhaoliu", 10, 50));
        System.out.println(treeSet);


        // 存到arrayList中
        ArrayList<Employee> arrayList = new ArrayList<>();
        for (Employee employee : treeSet) {
            arrayList.add(employee);
        }
        // 打印前两个积分最高的
        for (int i = 0; i < 2; i++) {
            System.out.println(arrayList.get(i));
        }
    }

    private static void method2() {
        // 需求: 往Treeset 去添加3个Student对象, 这个Student有name 有age , 我希望按照age进行排序
        TreeSet<Student> treeSet = new TreeSet();
        treeSet.add(new Student("zhangsan", 18));
        treeSet.add(new Student("lisi", 10));
        treeSet.add(new Student("wangwu", 30));

        System.out.println(treeSet);

        /**
         * 为什么之前在比较Integer类型字符串类型 long  他可以直接帮助我们比较
         * 那是因为这些类型都已经实现了Comparable
         *
         * 在treeset内部默认使用的就是compareable 当中有个compare方法 进行比较
         * 我们都知道treeset底层是用红黑树, 在添加节点的时候要进行比较动作才能进行添加,这个比较就是调用compare方法
         *
         * 也就说我们添加到treeset当中元素, 必须要实现comparable接口, 他才能够进行比较
         * 我们现在集合元素是Student 有实现Compareable接口 ? 没有实现.  没有实现无法进行比较
         *
         *  想要解决: 实现comparable接口 ,他有一个比较方法
         *  public interface Comparable<T> {
         * 	   public int compareTo(T o);
         * }
         * - this  <    o：返回负整数  -1，存储在左边
         * - this  ==  o： 返回		     0，此时认为两个对象内容相同，元素不能加入集合中。
         * - this  >    o：返回正整数   1，存储在右边
         *
         */

    }

    private static void method1() {
        // Treeset 常用api
//        add(E e)：添加元素到集合中。如果该元素已经存在，则不会添加。
//        contains(Object o)：如果集合包含指定的元素，则返回 true。
//        remove(Object o)：从集合中移除指定的元素，如果存在的话。
//        clear()：移除此集合中的所有元素。
//        size()：返回集合中的元素数量。
        // 1 创建treeset
        // 底层数据结构采用是红黑树
        /**
         * treeset 特点: 1 排序   2 去重
         * hashset 特点: 1 无序   2 去重
         *
         * 如果对排序没有要求:  使用hashSet 因为他底层使用的是hash表, 查数据速度比较快
         * 如果对排序有要求: 使用treeset
         *
         */
        TreeSet<Integer> treeSet = new TreeSet<>();
        treeSet.add(4);
        treeSet.add(2);
        treeSet.add(1);
        treeSet.add(5);
        System.out.println(treeSet);

        // 判断treeset 当中是否包含元素
        boolean contains = treeSet.contains(4);
        System.out.println(contains);
        // 删除treeset 当中元素
        treeSet.remove(4);
        System.out.println(treeSet);
        System.out.println(treeSet.size());
        treeSet.clear();
        System.out.println(treeSet);
    }


}
